const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const shipment_updates = sequelize.define(
    'shipment_updates',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

shipment_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"label_created",


"picked_up",


"in_transit",


"delivered",


"exception",


"returned"

        ],

      },

carrier: {
        type: DataTypes.TEXT,
      
      

      },

tracking_number: {
        type: DataTypes.TEXT,
      
      

      },

status_at: {
        type: DataTypes.DATE,
      
      

      },

status_details: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  shipment_updates.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity
































//end loop



    db.shipment_updates.belongsTo(db.orders, {
      as: 'order',
      foreignKey: {
        name: 'orderId',
      },
      constraints: false,
    });

    db.shipment_updates.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.shipment_updates.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.shipment_updates.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return shipment_updates;
};


